--- old/usr/src/uts/common/fs/smbsrv/smb_session.c	2020-04-15 01:43:38.398912014 +0000
+++ new/usr/src/uts/common/fs/smbsrv/smb_session.c	2020-04-15 01:43:38.403932420 +0000
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2019 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2020 RackTop Systems, Inc.
  */
 
 #include <sys/atomic.h>
@@ -857,6 +858,9 @@
 		    session->signing.mackey_len);
 	}
 
+	if (session->preauth_mech != NULL)
+		smb31_preauth_fini(session);
+
 	session->s_magic = 0;
 
 	smb_rwx_destroy(&session->s_lock);
